; Location: name desc items actors
; Item: name desc place
; Actor: name items location
; Owner: location | actor

(defparameter *location-type* (make-type))
(defparameter ROOM1 (make-address :key 'ROOM1 :type *location-type*))
(defparameter ROOM2 (make-address :key 'ROOM2 :type *location-type*))
(defparameter ROOM3 (make-address :key 'ROOM3 :type *location-type*))
(defparameter ROOM4 (make-address :key 'ROOM4 :type *location-type*))
(defparameter DEADEND (make-address :key 'DEADEND :type *location-type*))
(defparameter location-name
        (make-function 'enumerated-function 'location 'string 
                (function-values
                        '(ROOM1 . (make-string-address "ROOM1"))
                        '(ROOM2 . (make-string-address "ROOM2"))
                        '(ROOM3 . (make-string-address "ROOM3"))
                        '(ROOM4 . (make-string-address "ROOM4"))
                )
        )
)
(defparameter location-desc
        (make-function 'enumerated-function 'location 'string 
                (function-values
                        '(ROOM1 . (make-string-address
"A cold, dark room with a hallway going East and a hallway going South"))
                        '(ROOM2 . (make-string-address 
"A warm, well-lit room with a hallway going West and a hallway going South"))
                        '(ROOM3 . (make-string-address 
"A lukewarm, dim-lit room with a hallway going East and a hallway going North"))
                        '(ROOM4 . (make-string-address 
"A neutral feeling and neutral looking room with a hallway going West and a hallway going North"))
                )
        )
)
(defparameter *item-type* (make-type))
(defparameter SWORD     (make-address :key 'SWORD       :type *item-type*))
(defparameter NAPKIN    (make-address :key 'NAPKIN      :type *item-type*))
(defparameter WARCRAFT3 (make-address :key 'WARCRAFT3   :type *item-type*))
(defparameter item-name
        (make-function 'enumerated-function 'item 'string
                (function-values
                        '(SWORD . (make-string-address "sword"))
                        '(NAPKIN . (make-string-address "napkin"))
                        '(WARCRAFT3 . (make-string-address "War3 CD"))
                )
        )
)
(defparameter item-desc
        (make-function 'enumerated-function 'item 'string
                (function-values
                        '(SWORD . (make-string-address 
"A sharp, two-edged sword with a gold-plated hilt"))
                        '(NAPKIN . (make-string-address 
"A folded paper napkin with some scrawled text and unrecognizable drawings"))
                        '(WARCRAFT3 . (make-string-address 
"Warcraft III: Reign of Chaos^(tm) PC CD-ROM by Blizzard Entertainment"))
                )
        )
)
(defparameter item-owner
        (make-function 'enumerated-function 'item 'owner
                (function-values
                        '(SWORD . ROOM1)
                        '(NAPKIN . ROOM2)
                        '(WARCRAFT3 . ROOM3)
                )
        )
)

(defparameter *actor-type* (make-type))
(defparameter PLAYER1 (make-address :key 'PLAYER1 :type *actor-type*))
(defparameter actor-name
        (make-function 'enumerated-function 'actor 'string
                (function-values
                        '(PLAYER1 . (make-string-address "Hero"))
                )
        )
)
; actor-items?
(defparameter actor-location
        (make-function 'enumerated-function 'actor 'location
                (function-values
                        '(PLAYER1 . ROOM1)
                )
        )
)
(defparameter *direction-type* (make-type))
(defparameter N (make-address :type *direction-type* :key 'north))
(defparameter S (make-address :type *direction-type* :key 'south))
(defparameter E (make-address :type *direction-type* :key 'east))
(defparameter W (make-address :type *direction-type* :key 'west))
(defparameter PATH
        (make-function 'enumerated-function 'location 'function
                (function-values
                        '(ROOM1 .
                                (make-function 'enumerated-function 
                                                'direction 'location
                                        (function-values
                                                '(E . ROOM2)
                                                '(S . ROOM3)
                                                '(N . DEADEND)
                                                '(W . DEADEND)
                                        )
                                )
                        )
                        '(ROOM2 .
                                (make-function 'enumerated-function 
                                                'direction 'location
                                        (function-values
                                                '(W . ROOM1)
                                                '(S . ROOM4)
                                                '(N . DEADEND)
                                                '(E . DEADEND)
                                        )
                                )
                        )
                        '(ROOM3 .
                                (make-function 'enumerated-function 
                                                'direction 'location
                                        (function-values
                                                '(E . ROOM4)
                                                '(N . ROOM1)
                                                '(S . DEADEND)
                                                '(W . DEADEND)
                                        )
                                )
                        )
                        '(ROOM4 .
                                (make-function 'enumerated-function 
                                                'direction 'location
                                        (function-values
                                                '(N . ROOM2)
                                                '(W . ROOM3)
                                                '(S . DEADEND)
                                                '(E . DEADEND)
                                        )
                                )
                        )
                )
        )
)
<player commands>
