(in-package :max)
(defparameter *boolean-type* (make-type :key 'BOOLEAN))
(add-init-hook #'(lambda () (add-name *boolean-type* "boolean")))
(defparameter TRUE (make-address *boolean-type* :key 'TRUE))
(defparameter GET-TRUE 
    (make-function 'builtin-function *null-type* *boolean-type*
        #'(lambda (ignore-nil) TRUE)
))
(defparameter FALSE (make-address *boolean-type* :key 'FALSE))
(defparameter GET-FALSE
    (make-function 'builtin-function *null-type* *boolean-type*
        #'(lambda (ignore-nil) FALSE)
))
(add-init-hook #'(lambda () 
    (add-public-function get-true)
    (add-name get-true "true")
    (add-public-function get-false)
    (add-name get-false "false")
    (add-name true "true")
    (add-name false "false")
))
(defparameter boolean-not 
        (make-function 'enumerated-function *boolean-type* *boolean-type*
                (function-values
                        '(true . false)
                        '(false . true)
                )
                'BOOLEAN-NOT
        )
)
(add-init-hook #'(lambda () 
    (add-public-function boolean-not)
    (add-name boolean-not "not")
))

(defparameter boolean-identity
        (make-function 'enumerated-function *boolean-type* *boolean-type*
                (function-values
                        '(true . true)
                        '(false . false)
                )
                'BOOLEAN-IDENTITY
        )
)
(add-init-hook #'(lambda () 
    (add-public-function boolean-identity)
))

(defun boolean-cond (lisp-func)
    (if (funcall lisp-func) TRUE FALSE)
)

(add-init-hook #'(lambda ()
    (let ((boolean-and (make-function 'builtin-function
                (type-product *boolean-type* *boolean-type*)
                *boolean-type*
                #'(lambda (twobools)
                    (let ((vals (product-values twobools)))
                        (boolean-cond #'(lambda ()
                            (and
                                (addr-equal TRUE (first vals))
                                (addr-equal TRUE (second vals))
                            )
                        ))
                    )
                )))
          (boolean-or (make-function 'builtin-function
                (type-product *boolean-type* *boolean-type*)
                *boolean-type*
                #'(lambda (twobools)
                    (let ((vals (product-values twobools)))
                        (boolean-cond #'(lambda ()
                            (or
                                (addr-equal TRUE (first vals))
                                (addr-equal TRUE (second vals))
                            )
                        ))
                    )
                )))
        )

        (add-public-function boolean-and)
        (add-public-function boolean-or)
        (add-name boolean-and "and")
        (add-name boolean-or "or")
    )
))
