(require :maxdb)

(defparameter a (make-instance 'maxdb:file-database :filename "dbtest.out"))
;(defparameter x (max:make-string-address "Hello, world!"))
;(defparameter y (max:make-string-address "Hello 2"))

; cells broken right now
;(maxdb:make-cell a x)
;(maxdb:make-cell a x)
;(defparameter c (maxdb:make-cell a x))

;(format t "~A~%" (maxdb:cell-read c))

;(maxdb:cell-write c y)

;(defparameter n (max:make-number 2))
;(defparameter m (max:make-number 2.5))

;(maxdb:make-cell a n)
;(defparameter c2 (maxdb:make-cell a n))
;(maxdb:cell-write c2 m)

;---implementation line---

(defparameter globjtype (maxdb:make-type a :id "globj"))
#| (type globj) |#

; specify functions on type globj. In this case, structure members
; storing the x,y, and z coordinates.
; since even registered functions don't require names, maxdb returns a function address.
; maxdb:make-function deprecates max:make-function
(defparameter globj-x (maxdb:make-function a globjtype maxdb:*number-type* :id 'globj-x))
#|
(function globj-x)
(domain globj-x globj)
(codomain globj-x number)
|#
(defparameter globj-y (maxdb:make-function a globjtype maxdb:*number-type* :id 'globj-y))
#|
(function globj-y)
(domain globj-y globj)
(codomain globj-y number)
|#
(defparameter globj-z (maxdb:make-function a globjtype maxdb:*number-type* :id 'globj-z))
#|
(function globj-z)
(domain globj-z globj)
(codomain globj-z number)
|#

; Specify values for type globj. these are individual objects in the
; scene.  maxdb:transact starts a transaction that automatically ends at
; the end of its form body.  At the end of the transaction, MaxDB will
; check that all values are defined for all functions on the type and
; rollback in case of any problems.  globj foo at 0,0,0

; transact implementation.
; 1. (begin) - copy entire database to temporary file
; 2. transaction body: make changes to temporary file
; 3. (commit) - if transaction commits, rename temporary file atomically on top of original database
; 4. (rollback) - if transaction rolls back, erase temporary file.
;(maxdb:transact a
 (maxdb:type-add-value globjtype :id 'foo)
 (maxdb:function-update globj-x 'foo (max:make-number 0))
 (maxdb:function-update globj-y 'foo (max:make-number 0))
 (maxdb:function-update globj-z 'foo (max:make-number 0));)
#|
(globj foo)
(globj-x foo 0)
(globj-y foo 0)
(globj-z foo 0)
|#

; read back some values
(format t "foo's x coordinate: ~A~%" (maxdb:db-apply a globj-x 'foo))

