#| standalone test for relations |#

(require :maxdb)

(defparameter db (make-instance 'maxdb:file-database :filename "relationtest.max"))

(defparameter r (maxdb:make-relation db 'testrel maxdb:*number-type* maxdb:*number-type*))

(maxdb:relation-add-tuple r (max:make-number 2) (max:make-number 4))
(maxdb:relation-add-tuple r (max:make-number 2) (max:make-number 5))
(maxdb:relation-add-tuple r (max:make-number 3) (max:make-number 4))

(format t "set should say 4 5: ~A~%" (maxdb:relation-queryl r (max:make-number 2)))
(format t "set should say 2 3: ~A~%" (maxdb:relation-queryr r (max:make-number 4)))

(defparameter s (maxdb:make-relation db 'rel1m maxdb:*number-type* maxdb:*number-type* :cardinality :many-to-one))

; same inserts, but this time use many-to-one cardinality, so "leftid 2" should only have one tuple,
; this means the (2 4) will be replaced by (2 5).
(maxdb:relation-add-tuple s (max:make-number 2) (max:make-number 4))
(maxdb:relation-add-tuple s (max:make-number 2) (max:make-number 5))
(maxdb:relation-add-tuple s (max:make-number 3) (max:make-number 4))
; for clarity to show many-to-one
(maxdb:relation-add-tuple s (max:make-number 6) (max:make-number 4))

(format t "set should say 5: ~A~%" (maxdb:relation-queryl s (max:make-number 2)))
(format t "set should say 3 6: ~A~%" (maxdb:relation-queryr s (max:make-number 4)))
