(in-package :max)
(defclass source-type (max-type) nil)
(defparameter *sources* (make-type :class 'source-type :key 'SOURCE))

;(add-init-hook #'(lambda () (add-name *sources* "sources")))

(defclass source ()
    nil
)
; (defgeneric pull ..) would go here if it was needed

(defclass function-source (source)
    ((argsink :accessor argsink :initarg :argsink)
     (func :accessor func :initarg :func))
)

(defmethod pull ((fs function-source))
    (function-apply (func fs)
      (if (argsink fs)
         (source-pull (function-apply *switchboard*
                    (make-address-form (source-type fs) (argsink fs))
         ))
         nil
      )
    )
)

(defun source-pull (sourceaddr)
    (pull (addr-value sourceaddr))
)

(defmethod source-type ((fs function-source))
    (function-codomain (func fs))
)

(defun make-function-source (funcaddr &optional (sourceaddr nil))
  (let ((sink (if sourceaddr (make-sink (function-domain funcaddr) sourceaddr) nil)))
    (make-address-form (addr-value *sources*) 
        (make-instance 'function-source :func funcaddr :argsink (addr-value sink))
    )
  )
)
 
(defclass sink-type (max-type) nil)
(defparameter *sinks* (make-type :class 'sink-type :key 'SINK))
;(add-init-hook #'(lambda () (add-name *sinks* "sinks")))

(defclass sink () nil)

(defun make-sink (type sourceaddr)
  ; Typecheck
  (if (not (eq (source-type (addr-value sourceaddr)) type))
      (throw 'type-mismatch nil))

  (let ((sink (make-address-form (addr-value *sinks*) (make-instance 'sink))))

    (function-change-2 (function-implementation *switchboard*) sink sourceaddr)
    sink
  )
)
(defparameter *switchboard* 
    (make-function 'enumerated-function
        *sinks*
        *sources*
        (function-values)
    )
)
(add-init-hook #'(lambda ()
    (add-public-function *switchboard*)
    (add-name *switchboard* "switchboard")
))
