; ASDF system definition for Max
;
; This system definition assumes the .lisp files have
; already been built from the .nw files by Make

(defpackage :max
  (:use :cl :asdf)
  (:export max-type max-address addr-type addr-value make-string-address concatenate-string export-string *string-type* save-addr type-equal
           *number-type* make-number))

(in-package :max)

(defsystem :max
  :components
  ((:file "boolean" :depends-on ("max" "test" "type" "function"))
   (:file "catalog" :depends-on ("max" "ptr" "set"))
   (:file "eval" :depends-on ("type" "test" "function"))
   (:file "function" :depends-on ("max" "test" "type"))
   ; hack since I don't know how to use ASDF to call (init) after everything is loaded
   (:file "init" :depends-on ("boolean" "catalog" "eval" "function" "max" "menu" "name" "object" "ptr" "repl" "set" "string" "test" "type" "util"))
   (:file "max")
   (:file "menu" :depends-on ("max" "eval" "set"))
   (:file "name" :depends-on ("max" "object" "string" "ptr"))
   (:file "number" :depends-on ("max" "type"))
   (:file "object" :depends-on ("max" "type"))
   (:file "ptr" :depends-on ("type" "test"))
   (:file "repl" :depends-on ("menu" "string" "set" "function" "name"))
   (:file "set" :depends-on ("max" "test" "function"))
   (:file "string" :depends-on ("max"))
   (:file "test" :depends-on ("xptest"))
   (:file "type" :depends-on ("max" "test"))
   (:file "util")
   (:module xptest :components 
            ((:file "package")
             (:file "xptestsuite" :depends-on ("package"))
             (:file "xptest-example" :depends-on ("xptestsuite"))))))
