
(in-package max)

(defparameter *names* (make-ptr (get-empty-set (type-product *objects* *string-type*))))

(defun add-name (obj name)
    (let ((names (deref-ptr *names*)))
        (change-ptr *names* (set-add names
            (make-product-addr (set-type names) (list obj (make-string-address name)))))
    )
)
(defun get-names ()
    (deref-ptr *names*)
)
(add-init-hook #'(lambda ()
    (let ((get-names
            (make-function 'builtin-function
                *null-type*
                *set-type*
                #'(lambda (ignore-nil)
                    (get-names)
            ))
        ))

        (add-public-function get-names)
        (add-name get-names "names")
    )
))

(defun names (obj)
    (let ((result (get-empty-set *string-type*)))
        (mapset
            #'(lambda (item)
                (if (addr-equal obj (first (product-values item)))
                    (setq result (set-add result 
                        (make-address-form
                            (addr-value *string-type*)
                                (second (product-values  item))
                            )
                        )
                    )
                )
            )
            (deref-ptr *names*)
        )
        result
    )
)

(defun lookup (name)
    (let ((result (get-empty-set *objects*)))
        (mapset
            #'(lambda (item)
                (if (addr-equal name (second (product-values item)))
                    (setq result (set-add result 
                        (make-address-form
                            (addr-value *objects*)
                                (first (product-values  item))
                            )
                        )
                    )
                )
            )
            (deref-ptr *names*)
        )
        result
    )
)
