(in-package max)
(defclass string-type (max-type) nil)
(defparameter *string-type*
      (make-type :class 'string-type :key 'string)
)
(add-init-hook #'(lambda () (add-name *string-type* "strings")))
(defmethod addr-value-equal ((s string-type) a b)
        (equal a b)
)
(defun make-string-address (&optional (str ""))
        (make-address-form (addr-value *string-type*) str)
)
(defun export-string (str)
        (format nil "~a" (addr-value str)))
(defmethod save-addr-type ((addr max-address) (ty max-type))
        (export-string addr))
(defun print-string (str)
        (format t "~a~a~a" #\" (addr-value str) #\")
)

(defun string-concatenate (str1 str2)
        (make-string-address (concatenate 'string (addr-value str1) (addr-value str2)))
)
(add-init-hook #'(lambda ()
    (let ((string-concatenate
            (make-function 'builtin-function
                (type-product *string-type* *string-type*)
                *string-type*
                #'(lambda (twostrings)
                    (apply #'string-concatenate (product-values twostrings))
            ))
        ))

        (add-public-function string-concatenate)
        (add-name string-concatenate "concatenate")
    )
))
