(in-package :sdl)

; change mouse button event interface to support unlimited buttons
; redefine EXPAND-MOUSE-BUTTON:
(defun expand-mouse-button (event code)
  `(let ,(expand-bind-list
          `((x         (event-mouse-button-x     ,event))
            (y         (event-mouse-motion-y     ,event))
            (button    (event-mouse-button ,event)))
          (first code))
     ,@(rest code)))

; Add constant names for key scancodes

(def-foreign-constant +k-unknown+       0)
(def-foreign-constant +k-first+         0)
(def-foreign-constant +k-backspace+     8)
(def-foreign-constant +k-tab+           9)
(def-foreign-constant +k-clear+         12)
(def-foreign-constant +k-return+        13)
(def-foreign-constant +k-pause+         19)
(def-foreign-constant +k-escape+        27)
(def-foreign-constant +k-space+         32)
(def-foreign-constant +k-exclaim+       33)
(def-foreign-constant +k-quotedbl+      34)
(def-foreign-constant +k-hash+          35)
(def-foreign-constant +k-dollar+        36)
(def-foreign-constant +k-ampersand      38)
(def-foreign-constant +k-quote+         39)
(def-foreign-constant +k-leftparen+     40)
(def-foreign-constant +k-rightparen+    41)
(def-foreign-constant +k-asterisk+      42)
(def-foreign-constant +k-plus+          43)
(def-foreign-constant +k-comma+         44)
(def-foreign-constant +k-minus+         45)
(def-foreign-constant +k-period+        46)
(def-foreign-constant +k-slash+         47)
(def-foreign-constant +k-0+             48)
(def-foreign-constant +k-1+             49)
(def-foreign-constant +k-2+             50)
(def-foreign-constant +k-3+             51)
(def-foreign-constant +k-4+             52)
(def-foreign-constant +k-5+             53)
(def-foreign-constant +k-6+             54)
(def-foreign-constant +k-7+             55)
(def-foreign-constant +k-8+             56)
(def-foreign-constant +k-9+             57)
(def-foreign-constant +k-colon+         58)
(def-foreign-constant +k-semicolon+     59)
(def-foreign-constant +k-less+          60)
(def-foreign-constant +k-equals+        61)
(def-foreign-constant +k-greater+       62)
(def-foreign-constant +k-question+      63)
(def-foreign-constant +k-at+            64)

(def-foreign-constant +k-leftbracket+   91)
(def-foreign-constant +k-backslash+     92)
(def-foreign-constant +k-rightbracket+  93)
(def-foreign-constant +k-caret+         94)
(def-foreign-constant +k-underscore+    95)
(def-foreign-constant +k-backquote+     96)
(def-foreign-constant +k-a+             97)
(def-foreign-constant +k-b+             98)
(def-foreign-constant +k-c+             99)
(def-foreign-constant +k-d+             100)
(def-foreign-constant +k-e+             101)
(def-foreign-constant +k-f+             102)
(def-foreign-constant +k-g+             103)
(def-foreign-constant +k-h+             104)
(def-foreign-constant +k-i+             105)
(def-foreign-constant +k-j+             106)
(def-foreign-constant +k-k+             107)
(def-foreign-constant +k-l+             108)
(def-foreign-constant +k-m+             109)
(def-foreign-constant +k-n+             110)
(def-foreign-constant +k-o+             111)
(def-foreign-constant +k-p+             112)
(def-foreign-constant +k-q+             113)
(def-foreign-constant +k-r+             114)
(def-foreign-constant +k-s+             115)
(def-foreign-constant +k-t+             116)
(def-foreign-constant +k-u+             117)
(def-foreign-constant +k-v+             118)
(def-foreign-constant +k-w+             119)
(def-foreign-constant +k-x+             120)
(def-foreign-constant +k-y+             121)
(def-foreign-constant +k-z+             122)
(def-foreign-constant +k-delete+        127)
; Skip world symbols
(def-foreign-constant +k-kp0+           256)
(def-foreign-constant +k-kp1+           257)
(def-foreign-constant +k-kp2+           258)
(def-foreign-constant +k-kp3+           259)
(def-foreign-constant +k-kp4+           260)
(def-foreign-constant +k-kp5+           261)
(def-foreign-constant +k-kp6+           262)
(def-foreign-constant +k-kp7+           263)
(def-foreign-constant +k-kp8+           264)
(def-foreign-constant +k-kp9+           265)
(def-foreign-constant +k-kp-period+     266)
(def-foreign-constant +k-kp-divide+     267)
(def-foreign-constant +k-kp-multiply+   268)
(def-foreign-constant +k-kp-minus+      269)
(def-foreign-constant +k-kp-plus+       270)
(def-foreign-constant +k-kp-enter+      271)
(def-foreign-constant +k-kp-equals+     272)
(def-foreign-constant +k-up+            273)
(def-foreign-constant +k-down+          274)
(def-foreign-constant +k-right+         275)
(def-foreign-constant +k-left+          276)
(def-foreign-constant +k-insert+        277)
(def-foreign-constant +k-home+          278)
(def-foreign-constant +k-end+           279)
(def-foreign-constant +k-pageup+        280)
(def-foreign-constant +k-pagedown+      281)
(def-foreign-constant +k-f1+            282)
(def-foreign-constant +k-f2+            283)
(def-foreign-constant +k-f3+            284)
(def-foreign-constant +k-f4+            285)
(def-foreign-constant +k-f5+            286)
(def-foreign-constant +k-f6+            287)
(def-foreign-constant +k-f7+            288)
(def-foreign-constant +k-f8+            289)
(def-foreign-constant +k-f9+            290)
(def-foreign-constant +k-f10+           291)
(def-foreign-constant +k-f11+           292)
(def-foreign-constant +k-f12+           293)
(def-foreign-constant +k-f13+           294)
(def-foreign-constant +k-f14+           295)
(def-foreign-constant +k-f15+           296)
(def-foreign-constant +k-numlock+       300)
(def-foreign-constant +k-capslock+      301)
(def-foreign-constant +k-scrollock      302) ;sic
(def-foreign-constant +k-scrolllock     302)
(def-foreign-constant +k-rshift+        303)
(def-foreign-constant +k-lshift+        304)
(def-foreign-constant +k-rctrl+         305)
(def-foreign-constant +k-lctrl+         306)
(def-foreign-constant +k-ralt+          307)
(def-foreign-constant +k-lalt+          308)
(def-foreign-constant +k-rmeta+         309)
(def-foreign-constant +k-lmeta+         310)
(def-foreign-constant +k-lsuper+        311) ; Left "Windows" key
(def-foreign-constant +k-rsuper+        312) ; Right "Windows" key
(def-foreign-constant +k-mode+          313) ; "Alt Gr" key
(def-foreign-constant +k-compose+       314) ; Multi-key compose key
(def-foreign-constant +k-help+          315)
(def-foreign-constant +k-print+         316)
(def-foreign-constant +k-sysreq+        317)
(def-foreign-constant +k-break+         318)
(def-foreign-constant +k-menu+          319)
(def-foreign-constant +k-power+         320) ; Power Macintosh power key
(def-foreign-constant +k-euro+          321) ; Some European keyboards
(def-foreign-constant +k-undo+          322) ; Atari keyboard has Undo
(def-foreign-constant +k-last+          323)

(def-foreign-constant +kmod-none+       #x0000)
(def-foreign-constant +kmod-lshift+     #x0001)
(def-foreign-constant +kmod-rshift+     #x0002)
(def-foreign-constant +kmod-lctrl+      #x0040)
(def-foreign-constant +kmod-rctrl+      #x0080)
(def-foreign-constant +kmod-lalt+       #x0100)
(def-foreign-constant +kmod-ralt+       #x0200)
(def-foreign-constant +kmod-lmeta+      #x0400)
(def-foreign-constant +kmod-rmeta+      #x0800)
(def-foreign-constant +kmod-num+        #x1000)
(def-foreign-constant +kmod-caps+       #x2000)
(def-foreign-constant +kmod-mode+       #x4000)
(def-foreign-constant +kmod-reserved+   #x8000)

(def-foreign-constant +kmod-ctrl+       (logior +kmod-lctrl+ +kmod-rctrl+))
(def-foreign-constant +kmod-shift+      (logior +kmod-lshift+ +kmod-rshift+))
(def-foreign-constant +kmod-alt+        (logior +kmod-lalt+ +kmod-ralt+))
(def-foreign-constant +kmod-meta+       (logior +kmod-lmeta+ +kmod-rmeta+))

(def-foreign-constant +default-repeat-delay+     500)
(def-foreign-constant +default-repeat-interval+   30)
